package ppds;

import org.apache.commons.lang3.tuple.Pair;
import ppds.Types.ErrCode;
import ppds.Types.KeyType;

public class IXServer implements Server {
    public ErrCode create(KeyType type, String name) {
        System.out.println("Create a new index");
        return ErrCode.SUCCESS;
    }

    public ErrCode drop(String name) {
        System.out.println("Drop an existing index");
        return ErrCode.SUCCESS;
    }

    public Pair<ErrCode, IdxState> openIndex(String name) {
        System.out.println("Open a specific index");
        return Pair.of(ErrCode.SUCCESS, null);
    }

    public ErrCode closeIndex(IdxState idxState) {
        System.out.println("Terminate use of current index");
        return ErrCode.SUCCESS;
    }

    public Pair<ErrCode, TxnState> beginTransaction() {
        System.out.println("Signal the beginning of a transaction");
        return Pair.of(ErrCode.SUCCESS, null);
    }

    public ErrCode abortTransaction(TxnState txnState) {
        System.out.println("Force the current transaction to abort");
        return ErrCode.SUCCESS;
    }

    public ErrCode commitTransaction(TxnState txnState) {
        System.out.println("Signal the end of the current transaction");
        return ErrCode.SUCCESS;
    }

    public ErrCode get(IdxState idxState, TxnState txnState, Record record) {
        System.out.println("Retrieve the first record associated with the given key");
        return ErrCode.SUCCESS;
    }

    public ErrCode getNext(IdxState idxState, TxnState txnState, Record record) {
        System.out.println("Retrieve the record following the previous record retrieved by get or getNext");
        return ErrCode.SUCCESS;
    }

    public ErrCode insertRecord(IdxState idxState, TxnState txnState, Key<?> k, String payload) {
        System.out.println("Insert a payload associated with the given key");
        return ErrCode.SUCCESS;
    }

    public ErrCode delRecord(IdxState idxState, TxnState txnState, Record record) {
        System.out.println("Remove the record associated with the given key");
        return ErrCode.SUCCESS;
    }
}
